VERSION 5.00
Object = "{648A5603-2C6E-101B-82B6-000000000014}#1.1#0"; "MSCOMM32.OCX"
Begin VB.UserControl GPS 
   ClientHeight    =   1215
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   1200
   InvisibleAtRuntime=   -1  'True
   Picture         =   "GPS.ctx":0000
   ScaleHeight     =   1215
   ScaleWidth      =   1200
   ToolboxBitmap   =   "GPS.ctx":053E
   Begin MSCommLib.MSComm GPSComm 
      Left            =   600
      Top             =   600
      _ExtentX        =   1005
      _ExtentY        =   1005
      _Version        =   393216
      DTREnable       =   -1  'True
      RTSEnable       =   -1  'True
   End
End
Attribute VB_Name = "GPS"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Description = "K-tron GPS Controller for Real Time Positioning"
'******************************************************************************
'GPS ActiveX Component
'Author: Khalid Amin Khan     6th Oct.,2011
'Email: aminkhan@k-tron.net
'******************************************************************************
'
'Source Code of GPS ActiveX Component as discussed in the following paper.
'
'Khan et al., 2011, An ActiveX control for embedding GPS capability in custom
'applications, GPS Solutions, Vol.15, No.4, Pages.433439.
'DOI 10.1007/s10291-011-0236-6
'
'You are free to modify & distribute this program, provided the author's
'credits are not removed.
'******************************************************************************



'Working Flow Chart
'
' SetGPS ...
' GPSLogFile ...
' OpenGPS ... -------> GPSComm_OnComm
' CloseGPS                {
' GPSLogClose               gpsStream ~= .Input
'                           if line breaking Char found: gpsData ~= gpsStream
'                           Error Data Filters
'                           ProNMEA gpsData ---+--------> ProNMEA gpsData
'                         }                    |            {
'                                              |            if 1st Char = $
' OpenNMEA                                     |              if gpsLog: Write Log File
'   {                                          |              >> NMEASentence
'     Error Data Filters                       |              ParseData gpsData, gpsPara(), gpsNPara
'     ProNMEA gpsData -------------------------|              >> GGA ---------|
'   }                                                         >> GSA          |
'                                                             >> GSV          |
'                                                             >> RMC ---------+-----> ProcessCycle
'                                                             >> VTG          |         {
'                                                             >> GLL ---------|           >> UTMZoneChange
'                                                             >> RMA ---------|           >> UTMData
'                                                             >> RMB                      >> PositionChange
'                                                             >> User Defined           }
'                                                           }
'
'---------------------------------------------------------------------------------------------------------------------------------
                                'Events
Public Event NMEASentence(gpsData As String)
Public Event GGA(gpsTime As String, gpsLat As String, gpsLatNS As String, gpsLong As String, gpsLongEW As String, gpsFix As Integer, gpsSatUsed As Integer, gpsHDOP As Single, gpsAlt As Single, gpsAltUnit As String, gpsGeoidSep As Single, gpsGeoidUnit As String, gpsDGPSCorAge As Single, gpsDGPSRefStatID As String)
Public Event GSA(gpsMode1 As String, gpsMode2 As Integer, gpsSV() As Integer, gpsPDOP As Single, gpsHDOP As Single, gpsVDOP As Single)
Public Event GSV(gpsSatView As Integer, gpsSatID() As Integer, gpsSatElev() As Integer, gpsSatAzi() As Integer, gpsSatSNR() As Integer)
Public Event RMC(gpsTime As String, gpsDataStatus As String, gpsLat As String, gpsLatNS As String, gpsLong As String, gpsLongEW As String, gpsSpeedKnots As Single, gpsTrackAngle As Single, gpsDate As String, gpsMagVari As Single, gpsMagVariEW As String)
Public Event VTG(gpsTrackAngle As Single, gpsTrackTrueNorth As String, gpsMagTrack As Single, gpsMagRef As String, gpsSpeedKnots As Single, gpsUnitsKnots As String, gpsSpeedKMPH As Single, gpsUnitsKMPH As String)
Public Event GLL(gpsLat As String, gpsLatNS As String, gpsLong As String, gpsLongEW As String, gpsTime As String, gpsDataStatus As String)
Public Event RMA(gpsDataStatus As String, gpsLat As String, gpsLatNS As String, gpsLong As String, gpsLongEW As String, gpsSpeedKnots As Single, gpsTrackAngle As Single, gpsVariation As Single, gpsVariEW As String)
Public Event RMB(gpsDataStatus As String, gpsXTrackError As Single, gpsSteerDir As String, gpsOriginWayPointID As String, gpsDestWayPointID As String, gpsDestWayPointLat As Double, gpsLatNS As String, gpsDestWayPointLong As Double, gpsLongEW As String, gpsRange2Dest As Single, gpsBearing2Dest As Single, gpsVelocitytoDest As Single, gpsArrivalStatus As String)
Public Event UserDefinedSentence(userMsgID As String, userPara() As String, userNPara As Integer)
Public Event UTMData(LongDec As Double, LatDec As Double, Xutm As Double, Yutm As Double, Zone As Integer, Altitude As Single, AltitudeUnits As String)
Public Event PositionChange(LongDec As Double, LatDec As Double, Xutm As Double, Yutm As Double, Zone As Integer, Altitude As Single, AltitudeUnits As String)
Public Event UTMZoneChange(Zone As Integer)
Public Event GPSError(gpsErrNo As Integer, gpsErrDesc As String)
Public Event GPSScan(Port As Integer, Status As Integer)

                                'GPS Data, Log file & Error variables
Dim gpsStream As String                           'GPS input stream
Dim gpsLog As Boolean                             'GPS log file flag
Dim gpsFile As Boolean                            'GPS NMEA file open flag
Dim gpsScanPort As Boolean                        'GPS ScanPort flag
Dim gpsInitFilter As Boolean                      'GPS Initial Garbage Filter
Dim gpsGGAFirst As Boolean                        'GPS GGA to be First NMEA Sentence - Flag
Dim gpsGGACount As Integer                        ' '' Counter
Dim gpsErr As Integer                             'GPS Error #
Dim fnOut As Integer                              'File Number for Save Log File

                                'Arrays for NMEA Sentences
Dim gpsSV(24) As Integer                          'GSA
                                                  'GSV
Dim gpsSatID(24) As Integer, gpsSatElev(24) As Integer, gpsSatAzi(24) As Integer, gpsSatSNR(24) As Integer

                                'User-defined Device Data
Dim userDeviceName As String                      'Device Name
Dim userGPSOutID() As String                      'GPS Output Sentence ID
Dim userGPSIn() As String                         'GPS Input Sentence ID + Parameters
Dim userNGPSOut As Integer, userNGPSIn As Integer 'GPS Output/Input Sentences count

                                'GPS Data Cycle Memory
Dim memN(4) As Integer, memCycle As Integer
Dim memLong As String, memLongEW As String, memLat As String, memLatNS As String, memAlt As Single, memAltUnit As String
Dim memLong2 As String, memLat2 As String, memAlt2 As Single

                                'Last Processed Data Memory
Dim memLongDec As Double, memLatDec As Double, memXutm As Double, memYutm As Double, memZone As Integer

                                'UTM Zone Control Variables
Dim Zfix As Integer, FixFlag As Boolean, memZone2 As Integer, m_SetUTMZone2 As Integer

                                'Geodetic variables from [Geodetic.dll]
Dim ca#, cb#, cEo#, cNo#, cld0%, cph0%, csf#      'input grid parameters [.GPF]
Dim ce#                                           'calculated grid parameters
Dim ce2#, ce4#, ce6#, ceb#, cm0#                  'calculated additional parameters for UTM
                                'Conversion Factors
Const cpi# = 3.14159265358979                     'pie 22/7
Const cdr# = cpi / 180#                           'Survey of Pakistan value .017453292#
Const cym# = 0.9143988                            'yards to meters
Const cmf# = 3.28083333333333                     'meters to feet

                                'Default Property Values:
Const m_def_GPSErrorMsgBox = 0
Const m_def_SetUTMZone = -200
Const m_def_FixUTMZone = 0

                                'Property Variables:
Dim m_GPSErrorMsgBox As Boolean
Dim m_SetUTMZone As Integer
Dim m_FixUTMZone As Boolean

Public Sub SetGPS(ByVal gpsBaudRate As Long, ByVal gpsParity As String, ByVal gpsDataBits As Integer, ByVal gpsStopBits)
'Set GPS Communication Port Parameters
'gpsBaudRate& = Baud Rate [2400, 4800, 9600 ...]
'gpsParity$ = Parity [O=Odd, E=Even, N=None]
'gpsDataBits% = Data Bits
'gpsStopbits% = Stop Bits

With GPSComm
  .RThreshold = 2
                               
                               ' Sets and returns the number of characters the Input
                               ' property reads from the receive buffer
                               ' Setting InputLen to 0 causes the MSComm control to read the entire contents of the receive buffer when Input is used.
  .InputLen = 0
  .Settings = gpsBaudRate & ", " & gpsParity & ", " & gpsDataBits & ", " & gpsStopBits ' "9600,N ,8,1"
End With
End Sub

Public Sub OpenGPS(ByVal gpsComPort As Integer)
'Open GPS Communication Port
'ComPort% = Com Port #

On Local Error GoTo errOG

If gpsFile = True Then          'if GPS Data file already open then error message & exit
  ErrorMsg 10, "Cannot open Comm port when NMEA file is open."
  Exit Sub
End If

memCycle = 0                    'initialize control variables for GPS Data Cycle
gpsErr = 0                      'initialize error variable
gpsInitFilter = True            'set Garbage Filter flag
gpsGGAFirst = True              'set GGA First Filter flag & counter
gpsGGACount = 0

With GPSComm                    'Open Comm Port
  If .PortOpen = False Then
    .CommPort = gpsComPort
    .PortOpen = True
  Else
    .PortOpen = False
    .CommPort = gpsComPort
    .PortOpen = True
  End If
End With
Exit Sub

errOG:                          'error recovery
If Err = 8005 Then ErrorMsg 1, "Port already open."
End Sub

Public Sub CloseGPS()
'Close GPS Communication Port

With GPSComm
  If .PortOpen = True Then .PortOpen = False
End With
gpsStream = ""
End Sub

Public Sub GPSLogFile(ByVal LogFile As String, ByVal Mode As String)
'Create a GPS Log File
'LogFile = Log Filename (with path and extension)
'Mode = Open Mode [O=Output, A=Append]

If gpsFile = True Then          'if GPS Data file already open then error message & exit
  ErrorMsg 11, "Cannot create Log file when NMEA file is open."
  Exit Sub
End If

If gpsErr = 1 Then Exit Sub
fnOut = FileNumber(1)
If UCase(Mode) = "O" Then Open LogFile For Output As #fnOut
If UCase(Mode) = "A" Then Open LogFile For Append As #fnOut
gpsLog = True
End Sub

Public Sub GPSLogClose()
'Close GPS Log File

gpsLog = False
Close #fnOut
End Sub

Public Sub ResetGPSOutput()
'Reset/Clear User Defined GPS Output Sentences

userNGPSOut = 0
ReDim userGPSOutID(100) As String
End Sub

Public Sub AddGPSOutput(ByVal GPSOutputID As String)
'Add User Defined GPS Output Sentences
'GPSOutputID = GPS Output Sentence ID/Name

userNGPSOut = userNGPSOut + 1
userGPSOutID(userNGPSOut) = GPSOutputID
End Sub

Public Sub ResetGPSInput()
'Reset/Clear User Defined GPS Input Commands

userNGPSIn = 0
ReDim userGPSIn(100) As String
End Sub

Public Sub AddGPSInput(ByVal GPSInput As String)
'Add User Defined GPS Input Commands
'GPSInput = GPS Input Sentence

userNGPSIn = userNGPSIn + 1
userGPSIn(userNGPSIn) = GPSInput
End Sub

Public Sub SendGPSInput(ByVal InputMsgN As Integer)
'Send a User Defined GPS Input Command to the GPS unit
'InputMsgN = Command Index # according to the sequence of addition

Dim t%
If InputMsgN > 0 Then
  GPSComm.Output = userGPSIn(InputMsgN)
ElseIf InputMsgN = 0 Then
  For t% = 1 To userNGPSIn
    GPSComm.Output = userGPSIn(t)
  Next
End If
End Sub

Public Sub LoadGPSDriver(ByVal file As String)
'Load a GPS Driver with Proprietary Input/Output Commands for a GPS unit
'file = Driver file name

Dim XMLstream$                  'temp variables
Dim DrvIn$(100), DrvOut$(100), ni%, no%, t%
Dim fn%

fn = FileNumber(2)              'get file number
Open file For Input As #fn
Do
  Line Input #fn, XMLstream     'read GPS name & I/O commands from the driver file
  XMLvalue "DeviceName", XMLstream, userDeviceName
  XMLarray "<GPSInput>", XMLstream, DrvIn(), ni
  XMLarray "<GPSOutput>", XMLstream, DrvOut(), no
Loop Until EOF(fn)
Close #fn

ResetGPSInput                   'reset & add input commands
For t = 1 To ni
  Replace DrvIn(t), "[CR]", vbCr
  Replace DrvIn(t), "[LF]", vbLf
  AddGPSInput DrvIn(t)
Next
ResetGPSOutput                  'reset & add output sentences
For t = 1 To no
  Replace DrvIn(t), "[CR]", vbCr
  Replace DrvIn(t), "[LF]", vbLf
  AddGPSOutput DrvOut(t)
Next
End Sub

Public Sub ClearGPSDriver()
'Remove Driver / Clear the GPS Driver memory

userDeviceName = ""
ResetGPSInput
ResetGPSOutput
End Sub

Public Sub GetDecimal(ByVal DegMin As String, NDeg As Integer, Dec As Double)
'Get Decimal value of Lat/Long from the GPS output string
'DegMin = GPS Output Lat/Long string
'NDeg = Pick # of digits for decimal
'Dec = Decimal value of Lat/Long

Dim dm$                         'temp variable
dm = Trim(DegMin)
DMS2Decimal Val(Left$(dm, NDeg)), Val(Right$(dm, Len(dm) - NDeg)), 0, Dec
End Sub

Public Sub SignNSEW(Dec As Double, NSEW As String)
'Assigns the + - sign to the Latitude or Longitude according to the NSEW direction
'dec = Latitude or Longitude in decimal
'NSEW = N=North, S=South, E=East & W=West

If NSEW = "S" Then Dec = -1 * Dec
If NSEW = "W" Then Dec = -1 * Dec
End Sub

Public Sub Decimal2DMS(ByVal Dec As Double, Deg As Double, Min As Double, Sec As Double)
'From Geodetic.DLL::dec2dms
'Converts from decimal into deg,min,sec
'dec = input in decimal
'deg,min,sec = converted output in dms

Dim cpt#, csecl#, cerr, i%
If Dec < 0 Then i% = 1
cpt = Abs(Dec)
Deg = Int(cpt)
cpt = (cpt - Deg) * 60
Min = Int(cpt)
cpt = (cpt - Min) * 60
Sec = cpt

csecl = Sec * 10000             'remove unwanted decimal points
cerr = Abs(CLng(csecl) - csecl)
If cerr < 0.1 Then
  Sec = CLng(csecl) / 10000
  If Sec = 60 Then Sec = 0: Min = Min + 1
  If Min = 60 Then Min = 0: Deg = Deg + 1
End If

If i% = 1 Then                  'negative sign handling
  If Deg <> 0 Then Deg = -1 * Deg: Exit Sub
  If Min <> 0 Then Min = -1 * Min: Exit Sub
  If Sec <> 0 Then Sec = -1 * Sec: Exit Sub
End If
End Sub

Public Sub DMS2Decimal(ByVal Deg As Double, ByVal Min As Double, ByVal Sec As Double, Dec As Double)
'From Geodetic.DLL::dms2dec
'Converts from deg,min,sec into decimal
'deg,min,sec = inp in dms
'dec = converted output in decimal

Dim ca1#, cb1#, cc1#
ca1 = Abs(Deg) * 60
cb1 = (ca1 + Abs(Min)) * 60
cc1 = cb1 + Abs(Sec)
Dec = cc1 / 3600
If Deg < 0 Or Min < 0 Or Sec < 0 Then Dec = -Dec
End Sub

Public Sub UTMXY(ByVal Longitude As Double, ByVal Latitude As Double, x As Double, y As Double, cs As Double)
'From Geodetic.DLL::utmll2xy
'Converts input Longitude & Latitude into UTM  XY
'longitude,latitude = Input Longitude & Latitude from GPS (WGS-84)
'x,y = Output X(Easting / Westing), Y(Northing / Southing) in UTM
'cs = Output Scale

                                'temp variables
Dim cRlat#, cRlong#, cDelam#, cF1#, cF2#, cF3#, cF4#, cm#, cDlat#

cRlat = Latitude * cdr
cRlong = Longitude * cdr
cDelam = Longitude - cld0
If (cDelam < -180) Then cDelam = cDelam + 360
If (cDelam > 180) Then cDelam = cDelam - 360
'Test = Abs(cDelam)
'IF (Test > 3) THEN BEEP
cDelam = cDelam * cdr
cF1 = (1 - ce2 / 4 - 3 * ce4 / 64 - 5 * ce6 / 256) * cRlat
cF2 = (3 * ce2 / 8 + 3 * ce4 / 32 + 45 * ce6 / 1024) * Sin(2 * cRlat)
cF3 = (15 * ce4 / 256 + 45 * ce6 / 1024) * Sin(4 * cRlat)
cF4 = (35 * ce6 / 3072) * Sin(6 * cRlat)
cm = ca * (cF1 - cF2 + cF3 - cF4)
If (cDlat = 90 Or cDlat = -90) Then GoTo 1930
Dim ca1, cv, cn, cc, l$
cn = ca / Sqr(1 - ce2 * Sin(cRlat) ^ 2)
cv = Tan(cRlat) ^ 2
cc = ceb * Cos(cRlat) ^ 2
ca1 = Cos(cRlat) * cDelam
cF1 = (1 - cv + cc) * ca1 ^ 3 / 6
cF2 = (5 - 18 * cv + cv ^ 2 + 72 * cc - 58 * ceb) * ca1 ^ 5 / 120
x = csf * cn * (ca1 + cF1 + cF2)
cF1 = ca1 ^ 2 / 2
cF2 = (5 - cv + 9 * cc + 4 * cc ^ 2) * ca1 ^ 4 / 24
cF3 = (61 - 58 * cv + cv ^ 2 + 600 * cc - 330 * ceb) * ca1 ^ 6 / 720
y = csf * (cm - cm0 + cn * Tan(cRlat) * (cF1 + cF2 + cF3))
'If (l$ = "F") Then y = y * cmf
cF1 = 1 + ceb * Cos(cRlat) ^ 2
cF2 = x ^ 2 / (2 * csf ^ 2 * cn ^ 2)
cs = csf * (1 + cF1 * cF2)
GoTo 1960
1930 x = 0
y = csf * (cm - cm0)
cs = csf
1960:  x = x + cEo
y = y + cNo
End Sub

Public Sub UTMLL(ByVal x As Double, ByVal y As Double, Longitude As Double, Latitude As Double)
'From Geodetic.DLL::utmll2xy
'Converts input UTM  XY into Longitude & Latitude
'x,y = Input X(Easting / Westing), Y(Northing / Southing) in UTM
'longitude,latitude = Output Longitude & Latitude
'(ByVal cy#, ByVal cx#, cph#, cld#, ByVal t%)

                                'temp variables
Dim ce1#, ce0#, cn0#, cm#, cu#, cF1#, cF2#, cF3#, cRlat1#, cDlat1#, c1#, ct1#

ce0 = x - cEo
cn0 = y - cNo

ce1 = Sqr(1 - ce2)
ce1 = (1 - ce1) / (1 + ce1)

cm = cm0 + (cn0 / csf)

cu = cm / (ca * (1 - ce2 / 4 - 3 * ce4 / 64 - 5 * ce6 / 256))
cF1 = (3 * ce1 / 2 - 27 * ce1 ^ 3 / 32) * Sin(2 * cu)
cF2 = (21 * ce1 ^ 2 / 16 - 55 * ce1 ^ 4 / 32) * Sin(4 * cu)
cF3 = (151 * ce1 ^ 3 / 96) * Sin(6 * cu)
cRlat1 = cu + cF1 + cF2 + cF3
cDlat1 = cRlat1 / cdr
If (cDlat1 >= 90 Or cDlat1 <= -90) Then GoTo 2520
c1 = ceb * Cos(cRlat1) ^ 2
ct1 = Tan(cRlat1) ^ 2
cF1 = 1 - ce2 * Sin(cRlat1) ^ 2
Dim cn1, cR1, cd, cF4, cRlat, cRlong
cn1 = ca / Sqr(cF1)
cR1 = ca * (1 - ce2) / Sqr(cF1 ^ 3)
cd = ce0 / (cn1 * csf)
cF1 = cn1 * Tan(cRlat1) / cR1
cF2 = cd ^ 2 / 2
cF3 = (5 * 3 * ct1 + 10 * c1 - 4 * c1 ^ 2 - 9 * ceb) * cd ^ 4 / 24
cF4 = (61 + 90 * ct1 + 298 * c1 + 45 * ct1 ^ 2 - 252 * ceb - 3 * c1 ^ 2) * cd ^ 6 / 720
cRlat = cRlat1 - cF1 * (cF2 - cF3 + cF4)
Latitude = cRlat / cdr
cF1 = (1 + 2 * ct1 + c1) * cd ^ 3 / 6
cF2 = (5 - 2 * c1 + 28 * ct1 - 3 * c1 ^ 2 + 8 * ceb + 24 * ct1 ^ 2) * cd ^ 5 / 120
cRlong = cld0 * cdr + (cd - cF1 + cF2) / Cos(cRlat1)
Longitude = cRlong / cdr
If (Longitude < -180) Then Longitude = Longitude + 360
If (Longitude > 180) Then Longitude = Longitude - 360
Exit Sub
2520 If (cDlat1 >= 90) Then Latitude = 90
If (cDlat1 <= -90) Then Latitude = -90
Longitude = cld0
End Sub

Public Sub UTMZone(ByVal Longitude As Double, Zone As Integer, Cmeridian As Integer)
'Find UTM Zone & its Central Meridian from the input Longitude
'Longitude = Input Longitude of current position
'Zone = UTM Zone
'CMeridian = Central Meridian of the UTM Zone

Zone = Int(Longitude / 6) + 1
Cmeridian = (Zone * 6) - 3
Zone = Zone + 30
End Sub

Public Function UTMCMeridian(ByVal Zone As Integer) As Integer
'Return Central Meridian for the input Zone
'Zone = UTM Zone

UTMCMeridian = (Zone * 6) - 183
End Function

Public Sub OpenNMEA(ByVal file As String)
'Open NMEA Data file and Process it
'file = NMEA Data file name

Dim fn%, gpsData$               'temp variable
Dim ln%

If GPSComm.PortOpen = True Then 'if Comm port already open then error message & exit
  ErrorMsg 9, "Cannot open NMEA file when Comm Port is open."
  Exit Sub
End If

gpsFile = True                  'set file open flag
fn = FileNumber(3)              'get file number
Open file For Input As #fn      'open file for processing
Do
  Line Input #fn, gpsData
  
  ln = Len(gpsData)             'Error Data Filters
  If ln < 10 Or ln > 90 Then GoTo on1                     'length should be within range
  If InStr(1, gpsData, "$") <> 1 Then GoTo on1            '$ must be 1st Char
  If InStr(1, gpsData, "*") < ln - 5 Then GoTo on1        '* must be near end of line
  If InStr(1, gpsData, ",") = 0 Then GoTo on1             'at least 1 comma must be found
        
  ProNMEA gpsData               'Process NMEA Sentence
on1:
Loop Until EOF(fn)
Close #fn
gpsFile = False                 'reset file open flag
End Sub

Public Sub ProNMEA(gpsData As String)
'Process NMEA Sentences & parse out parameters array

On Error GoTo pnErr

Dim t%, u%                      'temp variables
Dim gpsPara$(25), userPara$(25), gpsNPara%

If Left(gpsData, 1) = "$" Then
                                'Write GPS Data - NMEA Sentence to Log File
  If gpsLog = True Then Print #fnOut, gpsData
                                'Raise Event for GPS Data - NMEA Sentence
  RaiseEvent NMEASentence(gpsData)
                                'Parse GPS Data - NMEA Sentence into Parameters Array
  ParseData gpsData, gpsPara(), gpsNPara
  If gpsNPara = 0 Then Exit Sub 'if any error encountered during parsing then exit sub
  
                                'NMEA-GGA Sentence: Global Positioning System Fix Data
  If gpsPara(1) = "$GPGGA" Or gpsPara(1) = "$GGA" Then
    If memCycle = 0 Then memN(1) = memN(1) + 1    'Initialize GPS Data Cycle
    If memCycle = 1 Then ProcessCycle             'Process GPS Data Cycle
    memLat = gpsPara(3)                           'Update the GPS Data Cycle Memory
    memLatNS = gpsPara(4)
    memLong = gpsPara(5)
    memLongEW = gpsPara(6)
    memAlt = Val(gpsPara(10))
    memAltUnit = gpsPara(11)
                                                  'Raise Event
    RaiseEvent GGA(gpsPara(2), gpsPara(3), gpsPara(4), gpsPara(5), gpsPara(6), Val(gpsPara(7)), Val(gpsPara(8)), Val(gpsPara(9)), Val(gpsPara(10)), gpsPara(11), Val(gpsPara(12)), gpsPara(13), Val(gpsPara(14)), gpsPara(15))
  End If
  
                                'NMEA-GSA Sentence: GNSS DOP & Active Satellites
  If gpsPara(1) = "$GPGSA" Or gpsPara(1) = "$GSA" Then
    For t = 1 To 12                               'load parameters into array
      gpsSV(t) = Val(gpsPara(3 + t))
    Next
    RaiseEvent GSA(gpsPara(2), Val(gpsPara(3)), gpsSV(), Val(gpsPara(16)), Val(gpsPara(17)), Val(gpsPara(18)))
  End If
  
                                'NMEA-GSV Sentence: GNSS Satellites in View
  If gpsPara(1) = "$GPGSV" Or gpsPara(1) = "$GSV" Then
    For t = 0 To 3                                'load parameters into arrays
      gpsSatID(1 + t + (Val(gpsPara(3)) - 1) * 4) = Val(gpsPara(5 + t * 4))
      gpsSatElev(1 + t + (Val(gpsPara(3)) - 1) * 4) = Val(gpsPara(6 + t * 4))
      gpsSatAzi(1 + t + (Val(gpsPara(3)) - 1) * 4) = Val(gpsPara(7 + t * 4))
      gpsSatSNR(1 + t + (Val(gpsPara(3)) - 1) * 4) = Val(gpsPara(8 + t * 4))
    Next
                                                  'if last GSV Sentence encountered then raise event
    If Val(gpsPara(2)) = Val(gpsPara(3)) Then
      RaiseEvent GSV(Val(gpsPara(4)), gpsSatID(), gpsSatElev(), gpsSatAzi(), gpsSatSNR())
    End If
  End If
  
                                'NMEA-RMC Sentence: Recommended Minimum Specific GNSS Data
  If gpsPara(1) = "$GPRMC" Or gpsPara(1) = "$RMC" Then
    If memCycle = 0 Then memN(2) = memN(2) + 1    'Initialize GPS Data Cycle
    If memCycle = 2 Then ProcessCycle             'Process GPS Data Cycle
    memLat = gpsPara(4)                           'Update the GPS Data Cycle Memory
    memLatNS = gpsPara(5)
    memLong = gpsPara(6)
    memLongEW = gpsPara(7)
                                                  'Raise Event
    RaiseEvent RMC(gpsPara(2), gpsPara(3), gpsPara(4), gpsPara(5), gpsPara(6), gpsPara(7), Val(gpsPara(8)), Val(gpsPara(9)), gpsPara(10), Val(gpsPara(11)), gpsPara(12))
  End If

                                'NMEA-VTG Sentence: Course Over Ground and Ground Speed
  If gpsPara(1) = "$GPVTG" Or gpsPara(1) = "$VTG" Then
    RaiseEvent VTG(Val(gpsPara(2)), gpsPara(3), Val(gpsPara(4)), gpsPara(5), Val(gpsPara(6)), gpsPara(7), Val(gpsPara(8)), gpsPara(9))
  End If

                                'NMEA-GLL Sentence: Geographic Position with Latitude/Longitude
  If gpsPara(1) = "$GPGLL" Or gpsPara(1) = "$GLL" Then
    If memCycle = 0 Then memN(3) = memN(3) + 1    'Initialize GPS Data Cycle
    If memCycle = 3 Then ProcessCycle             'Process GPS Data Cycle
    memLat = gpsPara(2)                           'Update the GPS Data Cycle Memory
    memLatNS = gpsPara(3)
    memLong = gpsPara(4)
    memLongEW = gpsPara(5)
                                                  'Raise Event
    RaiseEvent GLL(gpsPara(2), gpsPara(3), gpsPara(4), gpsPara(5), gpsPara(6), gpsPara(7))
  End If

                                'NMEA-RMA Sentence: Navigation Data for Present Position
  If gpsPara(1) = "$GPRMA" Or gpsPara(1) = "$RMA" Then
    If memCycle = 0 Then memN(4) = memN(4) + 1
    If memCycle = 4 Then ProcessCycle             'Process GPS Data Cycle
    memLat = gpsPara(3)                           'Update the GPS Data Cycle Memory
    memLatNS = gpsPara(4)
    memLong = gpsPara(5)
    memLongEW = gpsPara(6)
                                                  'Raise Event
    RaiseEvent RMA(gpsPara(2), gpsPara(3), gpsPara(4), gpsPara(5), gpsPara(6), Val(gpsPara(9)), Val(gpsPara(10)), Val(gpsPara(11)), gpsPara(12))
  End If

                                'NMEA-RMB Sentence: Recommended Minimum Navigation Information
  If gpsPara(1) = "$GPRMB" Or gpsPara(1) = "$RMB" Then
    RaiseEvent RMB(gpsPara(2), Val(gpsPara(3)), gpsPara(4), gpsPara(5), gpsPara(6), Val(gpsPara(7)), gpsPara(8), Val(gpsPara(9)), gpsPara(10), Val(gpsPara(11)), Val(gpsPara(12)), Val(gpsPara(13)), gpsPara(14))
  End If
        
                                'User Defined Sentences
  If userNGPSOut > 0 Then
    For t = 1 To userNGPSOut                      'Loop of User-defined Sentences
      If gpsPara(1) = userGPSOutID(t) Then        'if User-defined sentence found
        For u = 2 To gpsNPara                     'transfer parameters to new array (exclude 1st index containing Sentence ID)
          userPara(u - 1) = gpsPara(u)
        Next
        RaiseEvent UserDefinedSentence(gpsPara(1), userPara(), gpsNPara - 1)
      End If
    Next
  End If

End If

If memCycle = 0 Then            'Select the NMEA Statement [GGA,RMC,GLL,RMA] to be used as a trigger for the next GPS Data Cycle
  For t = 1 To 4
    If memN(t) = 2 Then
      For u = 1 To 4
        If memN(u) > 0 Then
          memCycle = u
          Exit For
        End If
      Next
    End If
    If memCycle > 0 Then Exit For
  Next
End If

Exit Sub
pnErr:                          'error recovery
End Sub

Public Function ScanPort(ByVal StartPort As Integer) As Integer
'Scan Comm Ports from StartPort to 10 and return the GPS Comm Port number
'StartPort = Starting Comm Port to scan the Comm Ports for GPS
'            Value: 1 - 10

On Local Error GoTo spErr

Dim t%                          'temp variables
gpsScanPort = True
With GPSComm
  For t% = StartPort To 10
    RaiseEvent GPSScan(t, 0)            'Scanning
    If .PortOpen = False Then
      .CommPort = t
      .PortOpen = True
    Else
      .PortOpen = False
      .CommPort = t
      .PortOpen = True
    End If
    Delay 2
    If gpsScanPort = False Then
       RaiseEvent GPSScan(t, 1)         'GPS found
       ScanPort = t
       Exit For
    Else
       RaiseEvent GPSScan(t, -1)        'GPS not found
    End If
sp1: Next
End With
gpsScanPort = False
Exit Function

spErr:                          'error recovery
If Err = 8005 Then                      'Port in use
    RaiseEvent GPSScan(t, -2)
    Resume sp1
End If
If Err = 8002 Then                      'Invalid port
    RaiseEvent GPSScan(t, -3)
    Resume sp1
End If
End Function

Public Sub Delay(ByVal Secs As Integer)
'Wait for the specified # of seconds
'Secs = Seconds to wait

Dim mTime$, i%                  'temp variable
dl:
i% = i% + 1
mTime = Time$
Do
  DoEvents
Loop Until mTime <> Time$
If i% < Secs Then GoTo dl:
End Sub

'--------------------------------------Control Initialization/Event Procs & Helper Methods
Private Sub GPSComm_OnComm()
'Comm Control Event Procedure

If gpsScanPort = True Then      'if in ScanPort mode & OnComm event occured then GPS found & therfore
  gpsScanPort = False                       'set flag
  GPSComm.PortOpen = False                  'close Comm Port &
  Exit Sub                                  'return
End If

Dim gpsNL$, p%                  'temp variables
Dim gpsData$
Dim ln%

gpsNL$ = Chr(13) & Chr(10)      'set line breaking characters [CRLF]

With GPSComm
  Select Case .CommEvent

                                'Error Message
  Case comEventBreak                        'A Break was received
    ErrorMsg 2, "A Break was received."
    .PortOpen = False
    .PortOpen = True
  Case comEventFrame                        'Framing Error
    ErrorMsg 3, "Framing Error."
    .PortOpen = False
    .PortOpen = True
  Case comEventOverrun                      'Data Lost
    ErrorMsg 4, "Data Lost."
    .PortOpen = False
    .PortOpen = True
  Case comEventRxOver                       'Receive buffer overflow
    ErrorMsg 5, "Receive buffer overflow."
    .PortOpen = False
    .PortOpen = True
  Case comEventRxParity                     'Parity Error
    ErrorMsg 6, "Parity Error."
    .PortOpen = False
    .PortOpen = True
  Case comEventTxFull                       'Transmit buffer full
    ErrorMsg 7, "Transmit buffer full."
    .PortOpen = False
    .PortOpen = True
  Case comEventDCB                          'Unexpected error retrieving DCB]
    ErrorMsg 8, "Unexpected error retrieving DCB."
    .PortOpen = False
    .PortOpen = True
  
                                'Event Messages
  Case comEvCD                              'Change in the CD line
    ErrorMsg -1, "GPS Event: Change in the CD line"
  Case comEvCTS                             'Change in the CTS line
    ErrorMsg -2, "GPS Event: Change in the CTS line"
  Case comEvDSR                             'Change in the DSR line
    ErrorMsg -3, "GPS Event: Change in the DSR line"
  Case comEvRing                            'Change in the Ring Indicator
    ErrorMsg -4, "GPS Event: Change in the Ring Indicator"
  
  
                                'Receive Data
  Case comEvReceive                         'Received RThreshold # of chars (Event)
    gpsStream = gpsStream & .Input          'Get GPS Data Stream
    
    p% = InStr(2, gpsStream, gpsNL)         'search the line breaking characters
    If p > 0 Then                           'Break Data Stream at the line breaking characters
  
      If gpsInitFilter = True Then          'Initial Garbage Filter (skip 1st record)
        gpsInitFilter = False
        gpsStream = ""
        Exit Sub
      End If
      
      gpsData = Mid(gpsStream, 1, p% - 1)   'Get GPS Data - NMEA Sentence
      
      If gpsGGAFirst = True Then            'Filter - GGA to be First NMEA Sentence
        gpsGGACount = gpsGGACount + 1
        If gpsGGACount = 10 Then gpsGGAFirst = False
        If Left(gpsData, 6) = "$GPGGA" Or Left(gpsData, 4) = "$GGA" Then
          gpsGGAFirst = False
        Else
          GoTo go1
        End If
      End If
      
      ln = Len(gpsData)                     'Error Data Filters
      If ln < 10 Or ln > 95 Then GoTo go1                 'length should be within range
      If InStr(1, gpsData, "$") <> 1 Then GoTo go1        '$ must be 1st Char
      If InStr(1, gpsData, "*") < ln - 5 Then GoTo go1    '* must be near end of line
      If InStr(1, gpsData, ",") = 0 Then GoTo go1         'at least 1 comma must be found
      
      ProNMEA gpsData                       'Process NMEA Sentence
                                          
go1:                                        'Remainder GPS Data Stream
      gpsStream = Mid(gpsStream, p% + Len(gpsNL))
    End If
  End Select
End With
End Sub

Private Sub ParseData(ByVal gpsData As String, gpsPara() As String, gpsNPara As Integer)
'Parse the gpsData sentence into an array of parameters
'gpsData = Input GPS Data string
'gpsPara() = Output GPS Parameters array
'gpsNPara = # of Output GPS Parameters

On Local Error GoTo pdErr

Dim p%                          'temp variable
Do
  p = InStr(1, gpsData, Chr$(44))
  If p > 0 Then
    gpsNPara = gpsNPara + 1
    gpsPara(gpsNPara) = Mid(gpsData, 1, p - 1) ''RTE9 Subscript out of range
    gpsData = Mid(gpsData, p + 1)
  End If
Loop Until p = 0
p = InStr(1, gpsData, "*")
gpsNPara = gpsNPara + 1
gpsPara(gpsNPara) = Mid(gpsData, 1, p - 1) ''RTE6 Invalid procedure call
gpsNPara = gpsNPara + 1
gpsPara(gpsNPara) = Mid(gpsData, p)
Exit Sub

pdErr:                          'error recovery
gpsNPara = 0
End Sub

Private Sub ProcessCycle()
'After getting GPS statements for a complete one cycle process the data for UTM X,Y conversions
'& activate Events

Dim cs#, zn%, ld0%              'temp variable

                                'if long-lat changed from last values then process

If memLong <> memLong2 Or memLat <> memLat2 Or m_SetUTMZone <> m_SetUTMZone2 Or FixFlag = True Then
  FixFlag = False                       'reset the FixUTMZone property flag
  GetDecimal memLong, 3, memLongDec     'get long-lat decimal values
  GetDecimal memLat, 2, memLatDec
  SignNSEW memLongDec, memLongEW        'assign sign according to NSEW
  SignNSEW memLatDec, memLatNS
  UTMZone memLongDec, zn, ld0           'find UTM Zone from current longitude position

                                        'fix UTM Zone & Central Meridian using current position (would replace any user defined Zone)
  If m_FixUTMZone = True And Zfix = 0 Then
    SetUTMZone = zn
    Zfix = 1
  End If
  
  If m_SetUTMZone = -200 Then           'change UTM Zone & Central Meridian using the latest position, if user defined Zone not specified
    memZone = zn
    cld0 = ld0
  End If
                                        'compute UTM X,Y
  UTMXY memLongDec, memLatDec, memXutm, memYutm, cs

  If zn <> memZone2 Then                'Raise UTM Zone Change Event
    memZone2 = zn
    RaiseEvent UTMZoneChange(zn)
  End If


End If
                                'Raise UTM Data Cycle Event
RaiseEvent UTMData(memLongDec, memLatDec, memXutm, memYutm, memZone, memAlt, memAltUnit)

                                'Raise Position Change Event
If memLong <> memLong2 Or memLat <> memLat2 Or memAlt <> memAlt2 Then
  memLong2 = memLong                    'remember last long-lat & elev values to avoid processing of the same point data & control event trigger
  memLat2 = memLat
  memAlt2 = memAlt
  RaiseEvent PositionChange(memLongDec, memLatDec, memXutm, memYutm, memZone, memAlt, memAltUnit)
End If

 m_SetUTMZone2 = m_SetUTMZone
End Sub

Private Sub ErrorMsg(gpsErrNo As Integer, gpsErrDesc As String)
'On Error display Error Message Box or activate GPSError event
'gpsErrNo = GPS Error #
'gpsErrDesc = GPS Error Description

Dim errType$                    'temp variable
gpsErr = gpsErrNo

If gpsErr < 0 Then errType = "GPS Event #"
If gpsErr > 0 And gpsErr < 10 Then errType = "GPS Communication Error #"
If gpsErr > 10 Then errType = "GPS NMEA Protocol Error #"

If m_GPSErrorMsgBox = True Then
  MsgBox errType & Str(gpsErr) & vbCrLf & gpsErrDesc, vbOKOnly, App.Title
Else
  RaiseEvent GPSError(gpsErr, gpsErrDesc)
End If
End Sub

Private Function FileNumber(StartFileNumber As Integer) As Integer
'Check the StartFileNumber, if unused then return it as FileNumber else keep on incrementing it by one until a valid unused # is found

On Local Error GoTo fne:
fn1:
Open App.Path & "\fn.tmp" For Output As #StartFileNumber
Close #StartFileNumber
FileNumber = StartFileNumber
Kill App.Path & "\fn.tmp"
Exit Function
fne:
StartFileNumber = StartFileNumber + 1
Resume fn1
End Function

Private Sub UserControl_Initialize()

'-----[Geodetic.DLL::ReadGPS]----------------------------------------------------------------------------------------------------
                                'Geodetic Parameters
Dim cBpr#, cF1#, cF2#, cF3#, cF4#                 'temp variables
                                          'Input Grid Parameters from ReadGPF
ca = 6378137                                      'semimajor axis [WGS-84]
cb = 6356752.31424518                             'semiminor axis
cEo = 500000                                      'false easting  [UTM Projection]
cNo = 0                                           'false northing
'cld0 = 69                                        'central meridian - longitude of grids true origin (all parameters are constant except this one which changes with UTM Zone)
cph0 = 0                                          'latitude of grids true origin
csf = 0.9996                                      'scale factor
                                          'Computed Parameters
ce = Sqr((ca ^ 2 - cb ^ 2) / ca ^ 2)              'eccentricity of the ellipse in meridian section
                                          'Computed Parameters needed only for UTM conversions
ce2 = ce ^ 2
ce4 = ce2 ^ 2
ce6 = ce2 * ce4
ceb = ce2 / (1 - ce2)
cBpr = cph0 * cdr
cF1 = (1 - ce2 / 4 - 3 * ce4 / 64 - 5 * ce6 / 256) * cBpr
cF2 = 3 * ce2 / 8 + 3 * ce4 / 32 + 45 * ce6 / 1024
cF2 = cF2 * Sin(2 * cBpr)
cF3 = 15 * ce4 / 256 + 45 * ce6 / 1024
cF3 = cF3 * Sin(4 * cBpr)
cF4 = 35 * ce6 / 3072
cF4 = cF4 * Sin(6 * cBpr)
cm0 = ca * (cF1 - cF2 + cF3 - cF4)
'--------------------------------------------------------------------------------------------------------------------------------

                                'initialize variable
m_SetUTMZone2 = m_def_SetUTMZone

'================ For testing ==============
'OpenNMEA App.Path & "\MyGPS.nme"
'SetGPS 4800, "N", 8, 1
'GPSLogFile App.Path & "\gps.log", "O"
'OpenGPS 3
End Sub

'Initialize Properties for User Control
Private Sub UserControl_InitProperties()
  m_GPSErrorMsgBox = m_def_GPSErrorMsgBox
  m_SetUTMZone = m_def_SetUTMZone
  m_FixUTMZone = m_def_FixUTMZone
End Sub

Private Sub UserControl_Resize()
Size 540, 540                   'fix the control size at Design Time
End Sub

'Load property values from storage
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
  m_GPSErrorMsgBox = PropBag.ReadProperty("GPSErrorMsgBox", m_def_GPSErrorMsgBox)
  m_SetUTMZone = PropBag.ReadProperty("SetUTMZone", m_def_SetUTMZone)
  m_FixUTMZone = PropBag.ReadProperty("FixUTMZone", m_def_FixUTMZone)
End Sub

'Write property values to storage
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
  Call PropBag.WriteProperty("GPSErrorMsgBox", m_GPSErrorMsgBox, m_def_GPSErrorMsgBox)
  Call PropBag.WriteProperty("SetUTMZone", m_SetUTMZone, m_def_SetUTMZone)
  Call PropBag.WriteProperty("FixUTMZone", m_FixUTMZone, m_def_FixUTMZone)
End Sub

'--------------------------------------Properties
'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=0,0,0,0
Public Property Get GPSErrorMsgBox() As Boolean
Attribute GPSErrorMsgBox.VB_Description = "If True, On Error display the Error Message Box else activate the GPSError Event"
  GPSErrorMsgBox = m_GPSErrorMsgBox
End Property

Public Property Let GPSErrorMsgBox(ByVal New_GPSErrorMsgBox As Boolean)
  m_GPSErrorMsgBox = New_GPSErrorMsgBox
  PropertyChanged "GPSErrorMsgBox"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=7,0,0,0
Public Property Get SetUTMZone() As Integer
Attribute SetUTMZone.VB_Description = "Set User Defined UTM Zone"
  SetUTMZone = m_SetUTMZone
End Property

Public Property Let SetUTMZone(ByVal New_SetUTMZone As Integer)
  m_SetUTMZone = New_SetUTMZone
  PropertyChanged "SetUTMZone"
  memZone = m_SetUTMZone
  cld0 = UTMCMeridian(m_SetUTMZone)
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=0,0,0,0
Public Property Get FixUTMZone() As Boolean
Attribute FixUTMZone.VB_Description = "If True, Fix UTM Zone according to the initial  GPS Data  Longitude, else change the Zone according to the incomming GPS Data Longitude"
  FixUTMZone = m_FixUTMZone
End Property

Public Property Let FixUTMZone(ByVal New_FixUTMZone As Boolean)
  If m_FixUTMZone = New_FixUTMZone Then Exit Property
  m_FixUTMZone = New_FixUTMZone
  PropertyChanged "FixUTMZone"
  SetUTMZone = m_def_SetUTMZone
  Zfix = 0
  FixFlag = True
End Property
