Attribute VB_Name = "XMLPro"
'/*
' IGS Empire Component
' K-tron Simple XML Files Processing Library Code [XMLPro.BAS]
' Visual Basic Applications only
' Development:  Khalid Amin Khan.
' Company:  K-tron Research Incorporated, Pakistan.
'
' IGS Empire 4.0   1.0 04.01.2008 - 06.01.2008 0005:00
'                               ----------------------
'                               TOTAL HOURS    0005:00
'*/..............................................................................
'
'Library Functions are used in a Do-Loop to return the Values of given XML Tags
'Files can have nested elements - the top level nesting tags & their respective end-tags are filtered
'For Tags of interest the tag, its value & end-tag must be in a single line
'All Tag arguments may or may not contain angle brackets "< >". Both <Data> & Data are correct.
'If brackets are not included they would automatically be included.
'Processes File Records of the following type.
'
'<Data>
'<X1> 2200740.45 </X1>
'<Y1> 932362.290 </Y1>
'</Data>
'
'Here <Data> & </Data> would be filetered & only values of <X1> & <Y1> are returned
'
Public Function GetXMLvalue(Tag As String, Dat As String) As String
'Search the given Tag in the input Data string & if found return its value
'Tag = Tag String
'Dat = Input Data String

Dim EndTag$, ps%, pe%           'temp variables
TagCheck Tag
ps = InStr(Dat, Tag)
If ps = 0 Then Exit Function
EndTag = "</" & Right$(Tag, Len(Tag) - 1)
ps = ps + Len(Tag)
pe = InStr(Dat, EndTag) - ps
GetXMLvalue = Trim(Mid$(Dat, ps, pe))
End Function

Public Sub XMLvalue(Tag As String, Dat As String, TagValue As String)
'Search the given Tag in the input Data string & if found return its value
'Tag = Tag String
'Dat = Input Data String
'TagValue = Tag Value String

Dim EndTag$, ps%, pe%           'temp variables
TagCheck Tag
ps = InStr(Dat, Tag)
If ps = 0 Then Exit Sub
EndTag = "</" & Right$(Tag, Len(Tag) - 1)
ps = ps + Len(Tag)
pe = InStr(Dat, EndTag) - ps
TagValue = Trim(Mid$(Dat, ps, pe))
End Sub

Public Sub XMLarray(Tag As String, Dat As String, TagArray() As String, ArrayCount As Integer)
'Search the given Tag in the input Data string & if found add it to the TagArray & increment the ArrayCount
'Tag = Tag String
'Dat = Input Data String
'TagArray = Tag Values Array
'ArrayCount = Tag Values Array Counter

Dim EndTag$, ps%, pe%           'temp variables
TagCheck Tag
ps = InStr(Dat, Tag)
If ps = 0 Then Exit Sub
EndTag = "</" & Right$(Tag, Len(Tag) - 1)
ps = ps + Len(Tag)
pe = InStr(Dat, EndTag) - ps
ArrayCount = ArrayCount + 1
TagArray(ArrayCount) = Trim(Mid$(Dat, ps, pe))
End Sub

Public Function GetXMLencode(Tag As String, TagValue As String) As String
'Enocode a value into XML using the input Tag
'Tag = Tag String
'TagValue = Tag Value String

Dim EndTag$                     'temp variables
TagCheck Tag
EndTag = "</" & Right$(Tag, Len(Tag) - 1)
GetXMLencode = Tag$ & Trim$(TagValue) & EndTag
End Function

Public Sub XMLencode(Tag As String, TagValue As String, XML As String)
'Enocode a value into XML using the input Tag
'Tag = Tag String
'TagValue = Tag Value String
'XML = Encoded XML String

Dim EndTag$                     'temp variables
TagCheck Tag
EndTag = "</" & Right$(Tag, Len(Tag) - 1)
XML = Tag$ & Trim$(TagValue) & EndTag
End Sub

Public Sub Replace(Dat As String, SearchText As String, ReplaceText As String)
'Search the SearchText in the input Dat String & if found replace it with the ReplaceText String
'Dat = Input/Output String in which replacement is to be done
'SearchText = String to be searched & replaced
'ReplaceText = String replacing the original SearchText String

Dim ps%, pe%, lDat$, rDat$      'temp variables
ps = InStr(Dat, SearchText)
If ps = 0 Then Exit Sub
pe = ps + Len(SearchText)
ps = ps - 1
lDat = Left(Dat, ps)
rDat = Mid(Dat, pe)
Dat = lDat & ReplaceText & rDat
End Sub

Private Sub TagCheck(Tag As String)
'Helper Methods
'Checks the Tag String if it has angle bracets "< >" on both sides
'If not adds them on both sides & retrun the Tag String

Tag = Trim(Tag)
If Left$(Tag, 1) <> "<" Then Tag = "<" & Tag
If Right$(Tag, 1) <> ">" Then Tag = Tag & ">"
End Sub
